/* ########################################################################

			 Smac file mode python

   File: python.sc
   Path: /mnt/LaCie/xcoral-3.49.61/SmacLib/python.sc
   Description: 
   Created: dim. mai  3 14:53:42 CEST 2020
   Author: Bruno Pages
   Modified: dim. mai  3 14:55:45 CEST 2020
   Last maintained by: Bruno Pages

   RCS $Revision$ $State$
   

   ########################################################################

   Note: 

   ########################################################################

   Copyright (c) : Bruno Pages

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   ######################################################################## */

void python_colorize_line()
{
  python_color_region (beginning_of_line(), end_of_line());
}

/* Mini mode Python */

int python_indent_step = 4;

void python_insert_and_colorize()
{
  int c = last_key();
  
  if ((c == '\t') && (python_indent_step != 8)) {
    int n = python_indent_step;
    
    while (n--)
      insert_char(' ');
  }
  else
    insert_char(c);
  
  if (current_buffer_is_colored())
    python_colorize_line();
}

void python_new_line()
{
  int pos = beginning_of_line();
  int last = (pos == 0) ? 0 : previous_char();
  int c = 0;
  
  if (current_buffer_is_colored())
    python_colorize_line();
  
  insert_char('\n');
  
  /* reuse indent of previous line */  
  while (strchr(" \t", c = the_char(pos))) {
    insert_char(c);
    pos += 1;
  }
  if (last == ':') {
    /* indent more */
    int n = python_indent_step;
    
    if (n == 8)
      insert_char('\t');
    else
      while (n--)
	insert_char(' ');
  }
}

{  
  create_mode("Python");
  
  key_def("Python", "\t", "python_insert_and_colorize");
  key_def("Python", "\r", "python_new_line");
  key_def("Python", " ", "python_insert_and_colorize");
  key_def("Python", "\"", "python_insert_and_colorize");
  key_def("Python", "\'", "python_insert_and_colorize");
  
  key_def("Python", "^[a", "goto_beginning_of_c_definition");
  key_def("Python", "^[f", "forward_c_form");
  key_def("Python", "^[b", "backward_c_form");

  key_def("Python", "^[d", "delete_next_c_form");
  key_def("Python", "^[\b", "delete_previous_c_form");
  key_def("Python", "^[\177", "delete_previous_c_form");
  
  key_def("Python", "^[u", "upcase_word");
  key_def("Python", "^[l", "downcase_word");
  key_def("Python", "^[c", "capitalize_word");
}

